Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.Designer.cs	(revision 2654)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.Designer.cs	(revision 2655)
@@ -32,7 +32,7 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (chooseItemDialog != null) chooseItemDialog.Dispose();
-      if (disposing && (components != null)) {
-        components.Dispose();
+      if (disposing) {
+        if (typeSelectorDialog != null) typeSelectorDialog.Dispose();
+        if (components != null) components.Dispose();
       }
       base.Dispose(disposing);
@@ -46,72 +46,105 @@
     /// </summary>
     private void InitializeComponent() {
-      this.nameLabel = new System.Windows.Forms.Label();
-      this.nameTextBox = new System.Windows.Forms.TextBox();
-      this.valueLabel = new System.Windows.Forms.Label();
-      this.valueTextBox = new System.Windows.Forms.TextBox();
-      this.editorGroupBox = new System.Windows.Forms.GroupBox();
-      this.setVariableValueButton = new System.Windows.Forms.Button();
+      this.components = new System.ComponentModel.Container();
+      this.dataTypeLabel = new System.Windows.Forms.Label();
+      this.dataTypeTextBox = new System.Windows.Forms.TextBox();
+      this.valueGroupBox = new System.Windows.Forms.GroupBox();
+      this.valuePanel = new System.Windows.Forms.Panel();
+      this.viewHost = new HeuristicLab.Core.Views.ViewHost();
+      this.clearValueButton = new System.Windows.Forms.Button();
+      this.setValueButton = new System.Windows.Forms.Button();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.valueGroupBox.SuspendLayout();
+      this.valuePanel.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // nameLabel
-      // 
-      this.nameLabel.AutoSize = true;
-      this.nameLabel.Location = new System.Drawing.Point(3, 3);
-      this.nameLabel.Name = "nameLabel";
-      this.nameLabel.Size = new System.Drawing.Size(38, 13);
-      this.nameLabel.TabIndex = 0;
-      this.nameLabel.Text = "&Name:";
       // 
       // nameTextBox
       // 
-      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.nameTextBox.Size = new System.Drawing.Size(285, 20);
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.nameTextBox.Location = new System.Drawing.Point(50, 0);
-      this.nameTextBox.Name = "nameTextBox";
-      this.nameTextBox.Size = new System.Drawing.Size(153, 20);
-      this.nameTextBox.TabIndex = 1;
-      this.nameTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.nameTextBox_Validating);
+      this.descriptionTextBox.Size = new System.Drawing.Size(285, 62);
       // 
-      // valueLabel
+      // dataTypeLabel
       // 
-      this.valueLabel.AutoSize = true;
-      this.valueLabel.Location = new System.Drawing.Point(3, 29);
-      this.valueLabel.Name = "valueLabel";
-      this.valueLabel.Size = new System.Drawing.Size(37, 13);
-      this.valueLabel.TabIndex = 2;
-      this.valueLabel.Text = "&Value:";
+      this.dataTypeLabel.AutoSize = true;
+      this.dataTypeLabel.Location = new System.Drawing.Point(3, 98);
+      this.dataTypeLabel.Name = "dataTypeLabel";
+      this.dataTypeLabel.Size = new System.Drawing.Size(60, 13);
+      this.dataTypeLabel.TabIndex = 4;
+      this.dataTypeLabel.Text = "Data &Type:";
       // 
-      // valueTextBox
+      // dataTypeTextBox
       // 
-      this.valueTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.dataTypeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.valueTextBox.Location = new System.Drawing.Point(50, 26);
-      this.valueTextBox.Name = "valueTextBox";
-      this.valueTextBox.ReadOnly = true;
-      this.valueTextBox.Size = new System.Drawing.Size(99, 20);
-      this.valueTextBox.TabIndex = 3;
+      this.dataTypeTextBox.Location = new System.Drawing.Point(72, 94);
+      this.dataTypeTextBox.Name = "dataTypeTextBox";
+      this.dataTypeTextBox.ReadOnly = true;
+      this.dataTypeTextBox.Size = new System.Drawing.Size(285, 20);
+      this.dataTypeTextBox.TabIndex = 5;
       // 
-      // editorGroupBox
+      // valueGroupBox
       // 
-      this.editorGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+      this.valueGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.editorGroupBox.Location = new System.Drawing.Point(0, 52);
-      this.editorGroupBox.Name = "editorGroupBox";
-      this.editorGroupBox.Size = new System.Drawing.Size(203, 102);
-      this.editorGroupBox.TabIndex = 5;
-      this.editorGroupBox.TabStop = false;
-      this.editorGroupBox.Text = "&Editor:";
+      this.valueGroupBox.Controls.Add(this.valuePanel);
+      this.valueGroupBox.Controls.Add(this.clearValueButton);
+      this.valueGroupBox.Controls.Add(this.setValueButton);
+      this.valueGroupBox.Location = new System.Drawing.Point(0, 120);
+      this.valueGroupBox.Name = "valueGroupBox";
+      this.valueGroupBox.Size = new System.Drawing.Size(359, 154);
+      this.valueGroupBox.TabIndex = 7;
+      this.valueGroupBox.TabStop = false;
+      this.valueGroupBox.Text = "&Value:";
       // 
-      // setVariableValueButton
+      // valuePanel
       // 
-      this.setVariableValueButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.setVariableValueButton.Location = new System.Drawing.Point(155, 26);
-      this.setVariableValueButton.Name = "setVariableValueButton";
-      this.setVariableValueButton.Size = new System.Drawing.Size(45, 20);
-      this.setVariableValueButton.TabIndex = 4;
-      this.setVariableValueButton.Text = "Set...";
-      this.setVariableValueButton.UseVisualStyleBackColor = true;
-      this.setVariableValueButton.Click += new System.EventHandler(this.setVariableValueButton_Click);
+      this.valuePanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.valuePanel.Controls.Add(this.viewHost);
+      this.valuePanel.Location = new System.Drawing.Point(3, 48);
+      this.valuePanel.Name = "valuePanel";
+      this.valuePanel.Size = new System.Drawing.Size(353, 103);
+      this.valuePanel.TabIndex = 2;
+      this.valuePanel.DragOver += new System.Windows.Forms.DragEventHandler(this.valuePanel_DragEnterOver);
+      this.valuePanel.DragDrop += new System.Windows.Forms.DragEventHandler(this.valuePanel_DragDrop);
+      this.valuePanel.DragEnter += new System.Windows.Forms.DragEventHandler(this.valuePanel_DragEnterOver);
+      // 
+      // viewHost
+      // 
+      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.viewHost.Location = new System.Drawing.Point(0, 0);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.Object = null;
+      this.viewHost.Size = new System.Drawing.Size(353, 103);
+      this.viewHost.TabIndex = 0;
+      // 
+      // clearValueButton
+      // 
+      this.clearValueButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Remove;
+      this.clearValueButton.Location = new System.Drawing.Point(35, 19);
+      this.clearValueButton.Name = "clearValueButton";
+      this.clearValueButton.Size = new System.Drawing.Size(23, 23);
+      this.clearValueButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.clearValueButton, "Clear Value");
+      this.clearValueButton.UseVisualStyleBackColor = true;
+      this.clearValueButton.Click += new System.EventHandler(this.clearValueButton_Click);
+      // 
+      // setValueButton
+      // 
+      this.setValueButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Add;
+      this.setValueButton.Location = new System.Drawing.Point(6, 19);
+      this.setValueButton.Name = "setValueButton";
+      this.setValueButton.Size = new System.Drawing.Size(23, 23);
+      this.setValueButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.setValueButton, "Set Value");
+      this.setValueButton.UseVisualStyleBackColor = true;
+      this.setValueButton.Click += new System.EventHandler(this.setValueButton_Click);
       // 
       // VariableView
@@ -119,12 +152,18 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.setVariableValueButton);
-      this.Controls.Add(this.editorGroupBox);
-      this.Controls.Add(this.valueTextBox);
-      this.Controls.Add(this.nameTextBox);
-      this.Controls.Add(this.valueLabel);
-      this.Controls.Add(this.nameLabel);
+      this.Controls.Add(this.valueGroupBox);
+      this.Controls.Add(this.dataTypeTextBox);
+      this.Controls.Add(this.dataTypeLabel);
       this.Name = "VariableView";
-      this.Size = new System.Drawing.Size(203, 154);
+      this.Size = new System.Drawing.Size(359, 274);
+      this.Controls.SetChildIndex(this.dataTypeLabel, 0);
+      this.Controls.SetChildIndex(this.dataTypeTextBox, 0);
+      this.Controls.SetChildIndex(this.valueGroupBox, 0);
+      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.descriptionLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.valueGroupBox.ResumeLayout(false);
+      this.valuePanel.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -134,10 +173,12 @@
     #endregion
 
-    private System.Windows.Forms.Label nameLabel;
-    private System.Windows.Forms.TextBox nameTextBox;
-    private System.Windows.Forms.Label valueLabel;
-    private System.Windows.Forms.TextBox valueTextBox;
-    private System.Windows.Forms.GroupBox editorGroupBox;
-    private System.Windows.Forms.Button setVariableValueButton;
+    private System.Windows.Forms.Label dataTypeLabel;
+    private System.Windows.Forms.TextBox dataTypeTextBox;
+    private System.Windows.Forms.GroupBox valueGroupBox;
+    private ViewHost viewHost;
+    private System.Windows.Forms.Button clearValueButton;
+    private System.Windows.Forms.ToolTip toolTip;
+    private System.Windows.Forms.Button setValueButton;
+    private System.Windows.Forms.Panel valuePanel;
   }
 }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 2654)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 2655)
@@ -31,9 +31,9 @@
 namespace HeuristicLab.Core.Views {
   /// <summary>
-  /// The visual representation of an <see cref="IVariable"/>.
+  /// The visual representation of a <see cref="Variable"/>.
   /// </summary>
   [Content(typeof(Variable), true)]
-  public partial class VariableView : ItemViewBase {
-    private ChooseItemDialog chooseItemDialog;
+  public partial class VariableView : NamedItemBaseView {
+    private TypeSelectorDialog typeSelectorDialog;
 
     /// <summary>
@@ -42,6 +42,6 @@
     /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="ViewBase"/>.
     /// No own data storage present.</remarks>
-    public IVariable Variable {
-      get { return (IVariable)Item; }
+    public Variable Variable {
+      get { return (Variable)Item; }
       set { base.Item = value; }
     }
@@ -59,5 +59,5 @@
     /// <remarks>Calls <see cref="VariableView()"/>.</remarks>
     /// <param name="variable">The variable to represent visually.</param>
-    public VariableView(IVariable variable)
+    public VariableView(Variable variable)
       : this() {
       Variable = variable;
@@ -68,76 +68,79 @@
     /// </summary>
     /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void RemoveItemEvents() {
-      Variable.NameChanged -= new EventHandler(Variable_NameChanged);
+    protected override void DeregisterObjectEvents() {
       Variable.ValueChanged -= new EventHandler(Variable_ValueChanged);
-      base.RemoveItemEvents();
+      base.DeregisterObjectEvents();
     }
+
     /// <summary>
     /// Adds eventhandlers to the underlying <see cref="IVariable"/>.
     /// </summary>
     /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void AddItemEvents() {
-      base.AddItemEvents();
-      Variable.NameChanged += new EventHandler(Variable_NameChanged);
+    protected override void RegisterObjectEvents() {
+      base.RegisterObjectEvents();
       Variable.ValueChanged += new EventHandler(Variable_ValueChanged);
     }
 
-    /// <summary>
-    /// Updates all controls with the latest data of the model.
-    /// </summary>
-    /// <remarks>Calls <see cref="ViewBase.UpdateControls"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void UpdateControls() {
-      base.UpdateControls();
-      valueTextBox.Text = "-";
-      valueTextBox.Enabled = false;
-      editorGroupBox.Controls.Clear();
-      editorGroupBox.Enabled = false;
+    protected override void OnObjectChanged() {
+      base.OnObjectChanged();
       if (Variable == null) {
         Caption = "Variable";
-        nameTextBox.Enabled = false;
+        dataTypeTextBox.Text = "-";
+        dataTypeTextBox.Enabled = false;
+        setValueButton.Enabled = false;
+        clearValueButton.Enabled = false;
+        valueGroupBox.Enabled = false;
+        viewHost.Object = null;
       } else {
         Caption = Variable.Name + " (" + Variable.GetType().Name + ")";
-        nameTextBox.Text = Variable.Name;
-        nameTextBox.Enabled = true;
-        if (Variable.Value != null) {
-          valueTextBox.Text = Variable.Value.GetType().FullName;
-          valueTextBox.Enabled = true;
-          Control editor = (Control)MainFormManager.CreateDefaultView(Variable.Value);
-          if (editor != null) {
-            editorGroupBox.Controls.Add(editor);
-            editor.Dock = DockStyle.Fill;
-            editorGroupBox.Enabled = true;
-          }
-        }
+        dataTypeTextBox.Text = Variable.Value == null ? "-" : Variable.Value.GetType().FullName;
+        dataTypeTextBox.Enabled = Variable.Value != null;
+        setValueButton.Enabled = Variable.Value == null;
+        clearValueButton.Enabled = Variable.Value != null;
+        valueGroupBox.Enabled = true;
+        viewHost.Object = Variable.Value;
       }
     }
 
-    private void Variable_NameChanged(object sender, EventArgs e) {
-      UpdateText();
-    }
-    private void UpdateText() {
+    private void Variable_ValueChanged(object sender, EventArgs e) {
       if (InvokeRequired)
-        Invoke(new MethodInvoker(UpdateText));
-      else
-        nameTextBox.Text = Variable.Name;
-    }
-    private void Variable_ValueChanged(object sender, EventArgs e) {
-      Refresh();
+        Invoke(new EventHandler(Variable_ValueChanged), sender, e);
+      else {
+        dataTypeTextBox.Text = Variable.Value == null ? "-" : Variable.Value.GetType().FullName;
+        dataTypeTextBox.Enabled = Variable.Value != null;
+        setValueButton.Enabled = Variable.Value == null;
+        clearValueButton.Enabled = Variable.Value != null;
+        viewHost.Object = Variable.Value;
+      }
     }
 
-    private void nameTextBox_Validating(object sender, CancelEventArgs e) {
-      Variable.Name = nameTextBox.Text;
-
-      // check if variable name was set successfully
-      e.Cancel = Variable.Name != nameTextBox.Text;
+    private void setValueButton_Click(object sender, EventArgs e) {
+      if (typeSelectorDialog == null) {
+        typeSelectorDialog = new TypeSelectorDialog();
+        typeSelectorDialog.Caption = "Select Value Type";
+        typeSelectorDialog.TypeSelector.Configure(typeof(IItem), false, false);
+      }
+      if (typeSelectorDialog.ShowDialog(this) == DialogResult.OK) {
+        Variable.Value = (IItem)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType();
+      }
     }
-
-    private void setVariableValueButton_Click(object sender, EventArgs e) {
-      if (chooseItemDialog == null) {
-        chooseItemDialog = new ChooseItemDialog();
-        chooseItemDialog.Caption = "Set Value";
+    private void clearValueButton_Click(object sender, EventArgs e) {
+      Variable.Value = null;
+    }
+    private void valuePanel_DragEnterOver(object sender, DragEventArgs e) {
+      e.Effect = DragDropEffects.None;
+      Type type = e.Data.GetData("Type") as Type;
+      if ((type != null) && (typeof(IItem).IsAssignableFrom(type))) {
+        if ((e.KeyState & 8) == 8) e.Effect = DragDropEffects.Copy;  // CTRL key
+        else if ((e.KeyState & 32) == 32) e.Effect = DragDropEffects.Move;  // ALT key
+        else e.Effect = DragDropEffects.Link;
       }
-      if (chooseItemDialog.ShowDialog(this) == DialogResult.OK)
-        Variable.Value = chooseItemDialog.Item;
+    }
+    private void valuePanel_DragDrop(object sender, DragEventArgs e) {
+      if (e.Effect != DragDropEffects.None) {
+        IItem item = e.Data.GetData("Value") as IItem;
+        if ((e.Effect & DragDropEffects.Copy) == DragDropEffects.Copy) item = (IItem)item.Clone();
+        Variable.Value = item;
+      }
     }
   }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.Designer.cs	(revision 2655)
@@ -0,0 +1,104 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core.Views {
+  partial class ViewHost {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.viewPanel = new System.Windows.Forms.Panel();
+      this.viewLabel = new System.Windows.Forms.Label();
+      this.viewComboBox = new System.Windows.Forms.ComboBox();
+      this.SuspendLayout();
+      // 
+      // viewPanel
+      // 
+      this.viewPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewPanel.Location = new System.Drawing.Point(0, 27);
+      this.viewPanel.Name = "viewPanel";
+      this.viewPanel.Size = new System.Drawing.Size(227, 157);
+      this.viewPanel.TabIndex = 2;
+      // 
+      // viewLabel
+      // 
+      this.viewLabel.AutoSize = true;
+      this.viewLabel.Location = new System.Drawing.Point(3, 3);
+      this.viewLabel.Name = "viewLabel";
+      this.viewLabel.Size = new System.Drawing.Size(33, 13);
+      this.viewLabel.TabIndex = 0;
+      this.viewLabel.Text = "&View:";
+      // 
+      // viewComboBox
+      // 
+      this.viewComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.viewComboBox.FormattingEnabled = true;
+      this.viewComboBox.Location = new System.Drawing.Point(44, 0);
+      this.viewComboBox.Name = "viewComboBox";
+      this.viewComboBox.Size = new System.Drawing.Size(183, 21);
+      this.viewComboBox.TabIndex = 1;
+      this.viewComboBox.SelectedIndexChanged += new System.EventHandler(this.viewComboBox_SelectedIndexChanged);
+      // 
+      // ViewHost
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.viewComboBox);
+      this.Controls.Add(this.viewLabel);
+      this.Controls.Add(this.viewPanel);
+      this.Name = "ViewHost";
+      this.Size = new System.Drawing.Size(227, 184);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Panel viewPanel;
+    private System.Windows.Forms.Label viewLabel;
+    private System.Windows.Forms.ComboBox viewComboBox;
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs	(revision 2655)
@@ -0,0 +1,93 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using System.Linq;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views { 
+  public partial class ViewHost : UserControl {
+    private object obj;
+    public object Object {
+      get { return obj; }
+      set {
+        if (value != obj) {
+          obj = value;
+          Initialize();
+        }
+      }
+    }
+
+    public ViewHost() {
+      InitializeComponent();
+      Initialize();
+    }
+
+    private void Initialize() {
+      viewLabel.Visible = false;
+      viewComboBox.Items.Clear();
+      viewComboBox.Enabled = false;
+      viewComboBox.Visible = false;
+      if (viewPanel.Controls.Count > 0) viewPanel.Controls[0].Dispose();
+      viewPanel.Controls.Clear();
+      viewPanel.Enabled = false;
+
+      if (Object != null) {
+        var viewTypes = from t in MainFormManager.GetViewTypes(Object.GetType())
+                        orderby t.Name ascending
+                        select t;
+        foreach (Type viewType in viewTypes)
+          viewComboBox.Items.Add(viewType);
+        if (viewComboBox.Items.Count > 0) {
+          viewLabel.Visible = true;
+          viewComboBox.Enabled = true;
+          viewComboBox.Visible = true;
+        }
+
+        Control view = (Control)MainFormManager.CreateDefaultView(Object);
+        if (view != null) {
+          viewPanel.Controls.Add(view);
+          viewPanel.Tag = view;
+          view.Dock = DockStyle.Fill;
+          viewPanel.Enabled = true;
+          viewComboBox.SelectedItem = view.GetType();
+        }
+      }
+    }
+
+    private void viewComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (viewComboBox.SelectedItem != viewPanel.Tag) {
+        if (viewPanel.Controls.Count > 0) viewPanel.Controls[0].Dispose();
+        viewPanel.Controls.Clear();
+        Control view = (Control)MainFormManager.CreateView((Type)viewComboBox.SelectedItem, Object);
+        viewPanel.Controls.Add(view);
+        viewPanel.Tag = view;
+        view.Dock = DockStyle.Fill;
+      }
+    }
+  }
+}
